import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import { Option } from 'fp-ts/lib/Option';
import Decoder from './Decoder';
export declare type Decoder<a> = Decoder<a>;
export declare function andThen<a, b>(decoderFn: (value: a) => Decoder<b>, decoder: Decoder<a>): Decoder<b>;
export declare function array<a>(decoder: Decoder<a>): Decoder<a[]>;
export declare function at<a>(keys: string[], decoder: Decoder<a>): Decoder<a>;
export declare function boolean(): Decoder<boolean>;
export declare function fail<a>(message: string): Decoder<a>;
export declare function field<a>(key: string, decoder: Decoder<a>): Decoder<a>;
export declare function index<a>(key: number, decoder: Decoder<a>): Decoder<a>;
export declare function map<a, b>(fn: (value: a) => b, decoder: Decoder<a>): Decoder<b>;
export declare function map2<a, b, c>(fn: (valueA: a, valueB: b) => c, decoderA: Decoder<a>, decoderB: Decoder<b>): Decoder<c>;
export declare function map3<a, b, c, d>(fn: (valueA: a, valueB: b, valueC: c) => d, decoderA: Decoder<a>, decoderB: Decoder<b>, decoderC: Decoder<c>): Decoder<d>;
export declare function nullD<a>(value: a): Decoder<a>;
export declare function nullable<a>(decoder: Decoder<a>): Decoder<Option<a>>;
export declare function number(): Decoder<number>;
export declare function oneOf<a>(decoders: NonEmptyArray<Decoder<a>>): Decoder<a>;
export declare function string(): Decoder<string>;
export declare function succeed<a>(value: a): Decoder<a>;
export declare function unknown(): Decoder<unknown>;
