"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var AndThen_1 = require("./AndThen");
var Array_1 = require("./Array");
var Boolean_1 = require("./Boolean");
var Fail_1 = require("./Fail");
var Field_1 = require("./Field");
var Map_1 = require("./Map");
var Map2_1 = require("./Map2");
var Map3_1 = require("./Map3");
var Null_1 = require("./Null");
var Nullable_1 = require("./Nullable");
var Number_1 = require("./Number");
var OneOf_1 = require("./OneOf");
var String_1 = require("./String");
var Succeed_1 = require("./Succeed");
var Unknown_1 = require("./Unknown");
function andThen(decoderFn, decoder) {
    return new AndThen_1.default(decoderFn, decoder);
}
exports.andThen = andThen;
function array(decoder) {
    return new Array_1.default(decoder);
}
exports.array = array;
function at(keys, decoder) {
    return keys.reduceRight(function (decoders, key) { return field(key, decoders); }, decoder);
}
exports.at = at;
function boolean() {
    return new Boolean_1.default();
}
exports.boolean = boolean;
function fail(message) {
    return new Fail_1.default(message);
}
exports.fail = fail;
function field(key, decoder) {
    return new Field_1.default(key, decoder);
}
exports.field = field;
function index(key, decoder) {
    return field("" + key, decoder);
}
exports.index = index;
function map(fn, decoder) {
    return new Map_1.default(fn, decoder);
}
exports.map = map;
function map2(fn, decoderA, decoderB) {
    return new Map2_1.default(fn, decoderA, decoderB);
}
exports.map2 = map2;
function map3(fn, decoderA, decoderB, decoderC) {
    return new Map3_1.default(fn, decoderA, decoderB, decoderC);
}
exports.map3 = map3;
function nullD(value) {
    return new Null_1.default(value);
}
exports.nullD = nullD;
function nullable(decoder) {
    return new Nullable_1.default(decoder);
}
exports.nullable = nullable;
function number() {
    return new Number_1.default();
}
exports.number = number;
function oneOf(decoders) {
    return new OneOf_1.default(decoders);
}
exports.oneOf = oneOf;
function string() {
    return new String_1.default();
}
exports.string = string;
function succeed(value) {
    return new Succeed_1.default(value);
}
exports.succeed = succeed;
function unknown() {
    return new Unknown_1.default();
}
exports.unknown = unknown;
